import { NetworkInterface } from './networkInterface';
import { GraphQLResult } from 'graphql';
import { ApolloStore } from './store';
import { QueryManager, WatchedQueryHandle, WatchQueryOptions } from './QueryManager';
export default class ApolloClient {
    networkInterface: NetworkInterface;
    store: ApolloStore;
    reduxRootKey: string;
    queryManager: QueryManager;
    constructor({networkInterface, store, reduxRootKey}?: {
        networkInterface?: NetworkInterface;
        store?: ApolloStore;
        reduxRootKey?: string;
    });
    watchQuery(options: WatchQueryOptions): WatchedQueryHandle;
    query(options: WatchQueryOptions): Promise<GraphQLResult | Error>;
    mutate(options: {
        mutation: string;
        variables?: Object;
    }): Promise<GraphQLResult>;
}
