import { NormalizedCache } from './data/store';
import { QueryStore } from './queries/store';
import { MutationStore } from './mutations/store';
import { ApolloAction } from './actions';
export interface Store {
    data: NormalizedCache;
    queries: QueryStore;
    mutations: MutationStore;
}
export interface ApolloStore {
    dispatch: (action: ApolloAction) => void;
    getState: () => Store;
    subscribe: (listener: () => void) => void;
}
export declare function apolloReducer(state: Store, action: ApolloAction): {
    queries: QueryStore;
    mutations: MutationStore;
    data: NormalizedCache;
};
export declare function createApolloStore(reduxRootKey?: string): ApolloStore;
